; Programme "CheniPB" la rotation sur PORTB est commande par RA0 et RA3

;Configuration du pic, des registres et appel des macros		
			config cp=non, pwrt=non, wdt=non, osc=xt ;Config du pic
			include "registres.h" 	;Appel du fichier des registres 
			include "stdmac.h"	;Appel du fichier des macros
					 		;(non utilis dans l'exemple)
;Dfinition des constantes
Tjaune		equ 3			;Touche jaune = RA3 = chenillard  droite	
Trouge		equ 0 		;Touche rouge = RA0 = chenillard  gauche	

;Rservaton des variables	
			org	0x20,zreg	;Origine de la zone registre libre (RAM)
Var 		rm	1		;Rservation d'une mmoire  "Var"
						;(non utilis dans l'exemple)
					
;********************* Programme principal ******************************
			org	0,zprog	;Origine d'implantation programme (ROM)
						;aprs Reset toujours  l'adresse 0
; Initialisation
Init		bsf	STATUS,RP0	ser en page 1 (accs  TRISB)
						;(PORTA toujours entrant aprs Reset)
			clrf	TRISB		;PORTB en sortie
			bcf	STATUS,RP0	;Repasser en page 0
			clrf	PORTB		;Tout PORTB  0
			bsf	PORTB,3	;Bit 3 du PORTB  1
			goto	Debut		;Branchement au dbut de la boucle

; Boucle 
Debut		call	RotDroite	;Saut au sp de rotation  droite 
			call	RotGauche	;Saut au sp de rotation  gauche
			goto	Debut		;Rebouclage 

;********************** Fin du programme principal **********************

;************************* Sous programmes (sp) *************************

;Dbut du sous programme RotDroite

RotDroite		btfsc	PORTA,Tjaune;RA3 est il  0 ? (Bouton jaune appuy ?)
			return		;non : alors retour au prg principal
			rrf	PORTB		;oui : alors rotation  droite PORTB
			call	T100mS	;Envoi vers le sp de temporisation 100ms
			return		;Retour au programme principal
			
; Fin du sous programme RotDroite

;********************************************
;Dbut du sous programme RotGauche

RotGauche		btfsc	PORTA,Trouge;RA0 est il  0 ? (Bouton rouge appuy ?)
			return		;non: alors retour au prg principal
			rlf	PORTB		;oui: alors rotation  gauche PORTB
			call	T100mS	;Envoi vers le sp de temporisation 100ms
			return		;Retour au programme principal

; Fin du sous programme RotGauche

;********************************************
;Sous programme de temporisations logicielle (fichier import)		

			include "Tempo4.inc"	;Fichier sous programme Tempo4
							;T1mS, T10mS, T100mS, T1S

; ********************* Fin des sous programmes **************************

;-------------------------------------------------------------------------
			end			;Fin du programme


